import mfd, pari, constants, misc

error="Some necessary data is missing from the database, so the computation can not be completed."
def lvals(D,N):
    ans = []
    for n in pari.divisors(N):
        S = mfd.ModSym(D*eval(n),2,0,'1','Q')
        facDn = pari.factor(D*eval(n))
        if not S.is_complete():
            return ["not all newforms in database"]
        # end if
        for f in S.get_iso_classes():
            wq = eval(f.atkin_lehner())
            if wq == constants.not_computed:
                return ["not all wq eigenvalues computed"]
            # end if
            wD = 1
            for i in range(len(wq)):
                if D % facDn[i][0] == 0:
                    wD = wD * wq[i]
                # end if
            # end for
            if wD == 1:
                ans.append(["%s%s"%(f.level,misc.ToIsogenyCode(f.iso_class)), f.lratio_odd_k2()])
            # end if
        # end for
    # end for
    return ans

def doit(bound):
    Ds = [6, 10, 14, 15, 21, 22, 26, 33, 34, 35, 38, 39, 46, \
         51, 55, 62, 69, 74, 86, 87, 94, 95, 111, 119, 134, \
         146, 159, 194, 206]

    for D in Ds:
        for N in range(2,bound/D+1):
            if pari.arecoprime(D,N):
                line = "[* %s,%s,%s *],"%(D,N,lvals(D,N))
                line = line.replace("'",'"')
                print line
